//*****************************************************
//**   Ivory Draw 1.0 Beta 4                         **
//**   DirectDraw component package for C++Builder   **
//*****************************************************

// (C) 1998 Tamas Demjen
// email: demjen@usa.net
// Web: http://members.xoom.com/demjen
// Ivory Draw on the Web: http://members.xoom.com/demjen/bcb/ivory.html

// This product is freeware, as described in license.txt
//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include "IvoryBitmap.h"
//---------------------------------------------------------------------------
#ifdef __IvoryBCB3__
#pragma package(smart_init)
#endif
//---------------------------------------------------------------------------
// internal variables:
static const TIvoryErrorClass iec = iecIvoryBitmap;
//---------------------------------------------------------------------------
static inline void ValidCtrCheckBitmap(TIvoryBitmap*)
{
   new TIvoryBitmap(NULL);
}
//---------------------------------------------------------------------------
__fastcall TIvoryBitmap::TIvoryBitmap(Classes::TComponent* AOwner)
 : TIvoryResFileBase(AOwner),
   FHandle(NULL),
   FWidth(0), FHeight(0),
   FPixels(NULL), FPitch(0),
   FOnChange(NULL)
{
}
//---------------------------------------------------------------------------
__fastcall TIvoryBitmap::~TIvoryBitmap()
{
   if(Handle) DeleteObject(Handle); // delete the bitmap object
}
//---------------------------------------------------------------------------
unsigned char* __fastcall TIvoryBitmap::GetScanLine(int Row) const
{
   return FPixels - FPitch * Row;
}
//---------------------------------------------------------------------------
// set a bitmap handle
void __fastcall TIvoryBitmap::SetHandle(HBITMAP handle)
{
   if(Handle != handle) // if a new handle specified
   {
      if(Handle) DeleteObject(Handle); // delete the last bitmap
      FHandle = handle; // assign the new handle
      BITMAP bm;
      GetObject(Handle, sizeof(bm), &bm);
      FPixels = (unsigned char*)bm.bmBits + bm.bmWidthBytes * (bm.bmHeight - 1);
      FPitch = bm.bmWidthBytes;
      FWidth = bm.bmWidth;
      FHeight = bm.bmHeight;
      if(OnChange) OnChange(this);
   }
}
//---------------------------------------------------------------------------
// load a bitmap from a file
void __fastcall TIvoryBitmap::LoadFromFile()
{
   if(ComponentState.Contains(csDesigning)) return;
   HBITMAP hbm = (HBITMAP)LoadImage(NULL, FileName.c_str(), IMAGE_BITMAP, 0, 0, LR_LOADFROMFILE | LR_CREATEDIBSECTION);
   if(hbm)
      Handle = hbm;
}
//---------------------------------------------------------------------------
// load a bitmap resource from the application or from a DLL
void __fastcall TIvoryBitmap::LoadFromResource()
{
   if(ComponentState.Contains(csDesigning)) return;
   if(DllHandle)
      Handle = (HBITMAP)LoadImage(DllHandle, ResourceName.c_str(), IMAGE_BITMAP, 0, 0, LR_CREATEDIBSECTION);
      // load from a DLL
   else
      Handle = (HBITMAP)LoadImage(GetModuleHandle(NULL), ResourceName.c_str(), IMAGE_BITMAP, 0, 0, LR_CREATEDIBSECTION);
      // load from the application
}
//---------------------------------------------------------------------------
// set bitmap from an array of colors
void __fastcall TIvoryBitmap::SetPixels(const unsigned char* pixels, int N_pixels)
{
   if(N_pixels <= Width*Height)
   {
      SetBitmapBits(Handle, N_pixels, pixels);
      if(OnChange) OnChange(this);
   }
}
//---------------------------------------------------------------------------
// get the array of colors from a bitmap
void __fastcall TIvoryBitmap::GetPixels(unsigned char* pixels, int N_pixels) const
{
   if(N_pixels <= Width*Height)
      GetBitmapBits(Handle, N_pixels, pixels);
}
//---------------------------------------------------------------------------

