//*****************************************************
//**   Ivory Draw 1.0 Beta 4                         **
//**   DirectDraw component package for C++Builder   **
//*****************************************************

// (C) 1998 Tamas Demjen
// email: demjen@usa.net
// Web: http://members.xoom.com/demjen
// Ivory Draw on the Web: http://members.xoom.com/demjen/bcb/ivory.html

// This product is freeware, as described in license.txt
//---------------------------------------------------------------------------
#ifndef IvoryBitmapSurfaceH
#define IvoryBitmapSurfaceH

#include "CustomIvorySurface.h"
//---------------------------------------------------------------------------
typedef void __fastcall (__closure* TPaintBitmapEvent)(System::TObject* Sender,
                         unsigned char* Memory, int Size, int FileType);
typedef void __fastcall (__closure* TUserFileFormatEvent)(System::TObject* Sender,
                         unsigned char* Memory, int Size, int& FileType, int& ImageWidth, int& ImageHeight);

class IVORY_package TIvoryBitmapSurface : public TCustomIvorySurface
{
private:
// private temporary data
   int Content; // 0:nothing, 1:file, 2:resource, 3:file that needs reload the next time, 4:resource that needs reload the next time
   unsigned char* Memory;
   int Size;
   int FileType;
   int ImageWidth;
   int ImageHeight;
   int OffsetPixels;
   int SizePixels;
// internal messages
   TPaintBitmapEvent FOnPaintBitmap;
   TUserFileFormatEvent FOnUserFileFormat;
protected:
   void __fastcall BitmapSurfaceRequestSize(TObject* Sender, int& Width, int& Height);
   void __fastcall LoadBMPFile(const String filename);
   void __fastcall LoadBMPResource(HMODULE hModule, const String resname);
   void __fastcall FastLoadBMP(unsigned char* Memory, int width, int height, int offsetpixels, int sizepixels);
   void __fastcall FastLoadPCX(unsigned char* Memory, int width, int height, int offsetpixels, int sizepixels);
   void __fastcall LoadFile();
   void __fastcall LoadResource();
   void __fastcall LoadFromFile();
   void __fastcall LoadFromResource();
// internal functions
   virtual void __fastcall RealizePaint();
// internal events
   __property TPaintBitmapEvent OnPaintBitmap = { read=FOnPaintBitmap, write=FOnPaintBitmap };
   __property TUserFileFormatEvent OnUserFileFormat = { read=FOnUserFileFormat, write=FOnUserFileFormat };
public:
// constructor
   __fastcall TIvoryBitmapSurface(TComponent* AOwner);
// destructor
   virtual __fastcall ~TIvoryBitmapSurface();
__published:
// published properties
   __property FileName;
   __property ResourceName;
   __property DllName;
   __property ShareDll;
   __property AutoCreate;
   __property Transparent;
   __property TransparentColor;
// published events
   __property OnPaint;
   __property OnCreate;
   __property OnDestroy;
   __property OnChange;
};
//---------------------------------------------------------------------------
#endif
