//*****************************************************
//**   Ivory Draw 1.0 Beta 4                         **
//**   DirectDraw component package for C++Builder   **
//*****************************************************

// (C) 1998 Tamas Demjen
// email: demjen@usa.net
// Web: http://members.xoom.com/demjen
// Ivory Draw on the Web: http://members.xoom.com/demjen/bcb/ivory.html

// This product is freeware, as described in license.txt
//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include "IvoryMapper.h"
//---------------------------------------------------------------------------
#ifdef __IvoryBCB3__
#pragma package(smart_init)
#endif
//---------------------------------------------------------------------------
// internal variables:
//static const TIvoryErrorClass iec = iecIvoryMapper;
//---------------------------------------------------------------------------
static inline void ValidCtrCheckMapper(TIvoryMapper*)
{
   new TIvoryMapper(NULL);
}
//---------------------------------------------------------------------------
__fastcall TIvoryMapper::TIvoryMapper(Classes::TComponent* AOwner)
 : TComponent(AOwner),
   FBitmap(NULL), FBitmapSurface(NULL),
   FTileWidth(0), FTileHeight(0), FTiles(0), FTileRows(0), FTileColumns(0)
{
}
//---------------------------------------------------------------------------
__fastcall TIvoryMapper::~TIvoryMapper()
{
}
//---------------------------------------------------------------------------
// calculate the number of tile rows
int __fastcall TIvoryMapper::GetTileRows() const
{
   if(TileHeight > 0)
   {
      if(Bitmap)
         return Bitmap->Height / TileHeight;
      else if(BitmapSurface)
         return BitmapSurface->Height / TileHeight;
      else
         return 0;
   }
   else
      return 0;
}
//---------------------------------------------------------------------------
// calcualte the number of tile columns
int __fastcall TIvoryMapper::GetTileColumns() const
{
   if(TileWidth > 0)
   {
      if(Bitmap)
         return Bitmap->Width / TileWidth;
      else if(BitmapSurface)
         return BitmapSurface->Width / TileWidth;
      else
         return 0;
   }
   else
      return 0;
}
//---------------------------------------------------------------------------
// calcualte the tile rectangle
TRect __fastcall TIvoryMapper::GetTileRect(int n) const
{
   int rows = TileRows, cols = TileColumns, maxtiles = min(rows * cols, Tiles);
   if(n < 0) n = 0;
   if(n >= maxtiles) n = maxtiles - 1;
   int x = n % cols * TileWidth, y = n / cols * TileHeight;
   return Rect(x, y, x + TileWidth, y + TileHeight);
}
//---------------------------------------------------------------------------
void __fastcall TIvoryMapper::SetBitmap(TIvoryBitmap* bitmap)
{
   FBitmap = bitmap;
   FBitmapSurface = NULL;
   FTileRows = GetTileRows();
   FTileColumns = GetTileColumns();
}
//---------------------------------------------------------------------------
void __fastcall TIvoryMapper::SetBitmapSurface(TCustomIvorySurface* bitmapsurface)
{
   FBitmap = NULL;
   FBitmapSurface = bitmapsurface;
   FTileRows = GetTileRows();
   FTileColumns = GetTileColumns();
}
//---------------------------------------------------------------------------

