//*****************************************************
//**   Ivory Draw 1.0 Beta 4                         **
//**   DirectDraw component package for C++Builder   **
//*****************************************************

// (C) 1998 Tamas Demjen
// email: demjen@usa.net
// Web: http://members.xoom.com/demjen
// Ivory Draw on the Web: http://members.xoom.com/demjen/bcb/ivory.html

// This product is freeware, as described in license.txt
//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "IvoryMiscUtils.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)
//---------------------------------------------------------------------------
void __fastcall ReadFileInfo(unsigned char* Memory, int Size, bool BitmapResource, int& filetype, int& width, int& height, int& offsetpal, int& sizepal, int& offsetpixels, int& sizepixels)
// Memory: pointer to the file loaded in the memory
// Size: the size of the file
// BitmapResource: true if it is a BITMAP resource, otherwise it is false
// filetype: -1:unknown, 1:BMP, 2:PCX
// width, height: width and height of the image, respectively
// offsetpal: the offset of the palette block
// sizepal: the size of the palette block
// offsetpixels: the offset of the pixels block
// sizepixels: the size of the pixels block
{
   filetype = -1;
   if(BitmapResource)
   {
      BITMAPINFOHEADER bih;
      int nClrUsed;

      memcpy(&bih, Memory, sizeof(bih));
      width = bih.biWidth;
      height = bih.biHeight;
      nClrUsed = (bih.biClrUsed) ? bih.biClrUsed : 1 << bih.biBitCount;
      offsetpal = sizeof(bih);
      sizepal = nClrUsed * sizeof(RGBQUAD);
      if(nClrUsed > 256) return;

      offsetpixels = offsetpal + sizepal;
      sizepixels = Size - offsetpixels;
      filetype = 1;
   }
   else
   {
      if(*Memory == 'B' && *(Memory+1) == 'M')
      {
         BITMAPFILEHEADER bfh;
         BITMAPINFOHEADER bih;
         int nClrUsed;

         memcpy(&bfh, Memory, sizeof(bfh));
         if(bfh.bfType != 'BM') return;
         memcpy(&bih, Memory + sizeof(bfh), sizeof(bih));
         width = bih.biWidth;
         height = bih.biHeight;
         nClrUsed = (bih.biClrUsed) ? bih.biClrUsed : 1 << bih.biBitCount;
         offsetpal = sizeof(bfh) + sizeof(bih);
         sizepal = nClrUsed * sizeof(RGBQUAD);

         offsetpixels = bfh.bfOffBits;
         sizepixels = Size - bfh.bfOffBits;
         filetype = 1;
      }
      else
      {
         TPcxHeader pcxheader;
         memcpy(&pcxheader, Memory, sizeof(pcxheader));
         if(pcxheader.Version != 5) return;
         width = pcxheader.xMax - pcxheader.xMin + 1;
         height = pcxheader.yMax - pcxheader.yMin + 1;
         offsetpixels = 128;
         sizepixels = Size - 128 - 769;
         offsetpal = Size - 768;
         sizepal = 768;
         filetype = 2;
      }
   }
}
//---------------------------------------------------------------------------
