//*****************************************************
//**   Ivory Draw 1.0 Beta 4                         **
//**   DirectDraw component package for C++Builder   **
//*****************************************************

// (C) 1998 Tamas Demjen
// email: demjen@usa.net
// Web: http://members.xoom.com/demjen
// Ivory Draw on the Web: http://members.xoom.com/demjen/bcb/ivory.html

// This product is freeware, as described in license.txt
//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "IvoryResFileBase.h"

//---------------------------------------------------------------------------
#ifdef __IvoryBCB3__
#pragma package(smart_init)
#endif
//---------------------------------------------------------------------------
__fastcall TIvoryResFileBase::TIvoryResFileBase(Classes::TComponent* AOwner)
 : TComponent(AOwner),
   FDllHandle(NULL),
   FFileName(""), FResourceName(""), FDllName(""),
   FDllLoaded(false), FShareDll(false)
{
}
//---------------------------------------------------------------------------
__fastcall TIvoryResFileBase::~TIvoryResFileBase()
{
   if(DllHandle && DllLoaded && !ShareDll) FreeLibrary(DllHandle); // free the DLL
   FDllHandle = NULL; FDllLoaded = false;
}
//---------------------------------------------------------------------------
// set a bitmap file name and load a bitmap from the file
void __fastcall TIvoryResFileBase::SetFileName(const String filename)
{
   if(FileName != filename) // if a new file name specified
   {
      FFileName = filename; // assign the new file name
      FResourceName = ""; // clear the resource name
      LoadFromFile(); // load the bitmap
   }
}
//---------------------------------------------------------------------------
// set a bitmap resource name and load the bitmap resource
void __fastcall TIvoryResFileBase::SetResourceName(const String resname)
{
   if(ResourceName != resname) // if new resource name specified
   {
      FResourceName = resname; // assign the new resource name
      FFileName = ""; // clear the file name
      LoadFromResource(); // load the bitmap
   }
}
//---------------------------------------------------------------------------
// set a new DLL handle
void __fastcall TIvoryResFileBase::SetDllHandle(HANDLE dllhandle)
{
   if(DllHandle != dllhandle) // if new handle specified
   {
      if(DllHandle && FDllLoaded && !ShareDll) FreeLibrary(DllHandle); // delete the old DLL
      FDllLoaded = false;
      FDllHandle = dllhandle; // assign the new handle
      if(DllHandle) // if the handle is valid
      {
         char fname[MAX_PATH];
         if(GetModuleFileName(DllHandle, fname, sizeof(fname)))
            FDllName = fname;
         else
            FDllName = "";
         // get the DLL's file name
      }
      else // if the handle is NULL
         FDllName = ""; // no DLL name
   }
}
//---------------------------------------------------------------------------
// set a new DLL file name
void __fastcall TIvoryResFileBase::SetDllName(const String dllname)
{
   DllHandle = LoadLibrary(dllname.c_str());
   if(DllHandle != GetModuleHandle(NULL))
      FDllLoaded = true;
}
//---------------------------------------------------------------------------
void __fastcall TIvoryResFileBase::LoadFromFile()
// must be overriden in descendants
{
}
//---------------------------------------------------------------------------
void __fastcall TIvoryResFileBase::LoadFromResource()
// must be overriden in descendants
{
}
//---------------------------------------------------------------------------

