//*****************************************************
//**   Ivory Draw 1.0 Beta 4                         **
//**   DirectDraw component package for C++Builder   **
//*****************************************************

// (C) 1998 Tamas Demjen
// email: demjen@usa.net
// Web: http://members.xoom.com/demjen
// Ivory Draw on the Web: http://members.xoom.com/demjen/bcb/ivory.html

// This product is freeware, as described in license.txt
//---------------------------------------------------------------------------
#ifndef IvorySurfaceH
#define IvorySurfaceH

#include "CustomIvorySurface.h"
#include "IvoryMapper.h"
//---------------------------------------------------------------------------
typedef void __fastcall (__closure* TGetMapEvent)(System::TObject* Sender,
                         int Row, int Col, int &MapIndex);

enum TIvoryDrawStyle { idsCenter, idsStretch, idsTile };

class IVORY_package TIvorySurface : public TCustomIvorySurface
{
private:
// child objects
   TIvoryMapper* FMapper;
   TIvoryBitmap* FBackgroundBitmap;
   TCustomIvorySurface* FBackgroundSurface;
// current state
   int FMapLeft;
   int FMapTop;
   int FMapColumns;
   int FMapRows;
   bool FMapEnabled;
   int* FMap;
   bool FDrawBackground;
   TIvoryDrawStyle FBackgroundDrawStyle;
// public messages
   TGetMapEvent FOnGetMap;
   Classes::TNotifyEvent FAfterDrawMap;
// getter and setter functions
   void __fastcall SetMapper(TIvoryMapper* mapper);
   void __fastcall SetMapLeft(int ml);
   void __fastcall SetMapTop(int mt);
   void __fastcall SetMapColumns(int mc);
   void __fastcall SetMapRows(int mr);
   void __fastcall SetMapEnabled(bool me);
   void __fastcall SetDrawBackground(bool db);
   void __fastcall SetBackgroundDrawStyle(TIvoryDrawStyle bds);
   void __fastcall SetBackgroundBitmap(TIvoryBitmap* bitmap);
   void __fastcall SetBackgroundSurface(TCustomIvorySurface* surface);
protected:
// internal functions
   virtual void __fastcall RealizePaint();
public:
// constructor
   __fastcall TIvorySurface(TComponent* AOwner);
// destructor
//   virtual __fastcall ~TIvorySurface();
// public functions
   void __fastcall DrawMap();
// public properties
   __property int* Map = { read=FMap, write=FMap };
__published:
// published properties
   __property AutoCreate;
   __property Width;
   __property Height;
   __property Transparent;
   __property TransparentColor;
   __property ClearBackground;
   __property BackgroundColor;
   __property TIvoryMapper* Mapper = { read=FMapper, write=SetMapper, default=NULL };
   __property int MapLeft = { read=FMapLeft, write=SetMapLeft, default=0 };
   __property int MapTop = { read=FMapTop, write=SetMapTop, default=0 };
   __property int MapColumns = { read=FMapColumns, write=SetMapColumns, default=0 };
   __property int MapRows = { read=FMapRows, write=SetMapRows, default=0 };
   __property bool MapEnabled = { read=FMapEnabled, write=SetMapEnabled, default=false };
   __property bool DrawBackground = { read=FDrawBackground, write=SetDrawBackground, default=false };
   __property TIvoryDrawStyle BackgroundDrawStyle = { read=FBackgroundDrawStyle, write=SetBackgroundDrawStyle, default=idsStretch };
   __property TIvoryBitmap* BackgroundBitmap = { read=FBackgroundBitmap, write=SetBackgroundBitmap, default=NULL };
   __property TCustomIvorySurface* BackgroundSurface = { read=FBackgroundSurface, write=SetBackgroundSurface, default=NULL };
// published events
   __property OnPaint;
   __property OnCreate;
   __property OnDestroy;
   __property OnChange;
   __property TGetMapEvent OnGetMap = { read=FOnGetMap, write=FOnGetMap, default=NULL };
   __property Classes::TNotifyEvent AfterDrawMap = { read=FAfterDrawMap, write=FAfterDrawMap, default=NULL };
};
//---------------------------------------------------------------------------
#endif
